 #region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// TSAC February 2016
    /// </summary>
    [Description("TSAC February 2016")]
    public class HigherHighLowerLowStochastics : Indicator
    {
        #region Variables
        // Wizard generated variables
            private int period = 20; // Default setting for Period
			private DataSeries HS;
			private DataSeries LS;
		
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
			Overlay				= false;
			
			
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "HHS"));
            Add(new Plot(Color.FromKnownColor(KnownColor.MediumVioletRed), PlotStyle.Line, "LLS"));
            
			HS = new DataSeries(this);
			LS = new DataSeries(this);
							
			
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
			if(CurrentBar < period)
			{
				return;	
			}
			
			if(High[0] > High[1])
			{
				HS.Set((High[0] - MIN(High, period)[0]) / (MAX(High,period)[0] - MIN(High, period)[0]));	
			}
			if(High[0] <= High[1])
			{
				HS.Set(0);	
			}
			if(Low[0] < Low[1])
			{
				LS.Set((MAX(Low, period)[0] - Low[0]) / (MAX(Low, period)[0] - MIN(Low, period)[0]));
			}
			if(Low[0] >= Low[1])
			{
				LS.Set(0);
			}
            HHS.Set(EMA(HS, period)[0] * 100);
            LLS.Set((EMA(LS, period)[0] * 100));
					
	        }
		
		

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries HHS
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries LLS
        {
            get { return Values[1]; }
        }
		
		[Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries HigherHigh
        {
            get { return Values[2]; }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int Period
        {
            get { return period; }
            set { period = Math.Max(1, value); }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private HigherHighLowerLowStochastics[] cacheHigherHighLowerLowStochastics = null;

        private static HigherHighLowerLowStochastics checkHigherHighLowerLowStochastics = new HigherHighLowerLowStochastics();

        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        public HigherHighLowerLowStochastics HigherHighLowerLowStochastics(int period)
        {
            return HigherHighLowerLowStochastics(Input, period);
        }

        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        public HigherHighLowerLowStochastics HigherHighLowerLowStochastics(Data.IDataSeries input, int period)
        {
            if (cacheHigherHighLowerLowStochastics != null)
                for (int idx = 0; idx < cacheHigherHighLowerLowStochastics.Length; idx++)
                    if (cacheHigherHighLowerLowStochastics[idx].Period == period && cacheHigherHighLowerLowStochastics[idx].EqualsInput(input))
                        return cacheHigherHighLowerLowStochastics[idx];

            lock (checkHigherHighLowerLowStochastics)
            {
                checkHigherHighLowerLowStochastics.Period = period;
                period = checkHigherHighLowerLowStochastics.Period;

                if (cacheHigherHighLowerLowStochastics != null)
                    for (int idx = 0; idx < cacheHigherHighLowerLowStochastics.Length; idx++)
                        if (cacheHigherHighLowerLowStochastics[idx].Period == period && cacheHigherHighLowerLowStochastics[idx].EqualsInput(input))
                            return cacheHigherHighLowerLowStochastics[idx];

                HigherHighLowerLowStochastics indicator = new HigherHighLowerLowStochastics();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                HigherHighLowerLowStochastics[] tmp = new HigherHighLowerLowStochastics[cacheHigherHighLowerLowStochastics == null ? 1 : cacheHigherHighLowerLowStochastics.Length + 1];
                if (cacheHigherHighLowerLowStochastics != null)
                    cacheHigherHighLowerLowStochastics.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheHigherHighLowerLowStochastics = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.HigherHighLowerLowStochastics HigherHighLowerLowStochastics(int period)
        {
            return _indicator.HigherHighLowerLowStochastics(Input, period);
        }

        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        public Indicator.HigherHighLowerLowStochastics HigherHighLowerLowStochastics(Data.IDataSeries input, int period)
        {
            return _indicator.HigherHighLowerLowStochastics(input, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.HigherHighLowerLowStochastics HigherHighLowerLowStochastics(int period)
        {
            return _indicator.HigherHighLowerLowStochastics(Input, period);
        }

        /// <summary>
        /// TSAC February 2016
        /// </summary>
        /// <returns></returns>
        public Indicator.HigherHighLowerLowStochastics HigherHighLowerLowStochastics(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.HigherHighLowerLowStochastics(input, period);
        }
    }
}
#endregion
